﻿using System;

namespace Neo4RestNet.ObjectMapping
{
  public class Property
  {
    private readonly Func<object, object> _getter;
    private readonly Action<object, object> _setter;

    internal Property(Func<object, object> getter, Action<object, object> setter, string name)
    {
      _getter = getter;
      _setter = setter;
      Name = name;
    }

    public string Name { get; set; } 

    public object Get(object instance)
    {
      return _getter(instance);
    }

    public void Set(object instance, object value)
    {
      _setter(instance, value);
    }
  }

  public class EmptyConstructor
  {
    public object Invoke()
    {
      return null;
    }
  }
}