﻿using System;
using System.Reflection;
using System.Reflection.Emit;

// This is some cool code that I stumbled upoan a while ago... 
// Need to google some more to see where I found it and to give credit to whomever wrote it!

namespace Neo4RestNet.ObjectMapping.Reflection
{
  static class EmitHelper
  {
    static readonly Module _module = typeof(EmitHelper).Module;
    static readonly Type[] _singleObject = new[] { typeof(object) };
    static readonly Type[] _twoObjects = new[] { typeof(object), typeof(object) };

    public static Action<object, object> CreatePropertySetterHandler(PropertyInfo propertyInfo)
    {
      var dynam = new DynamicMethod(string.Empty, typeof(void), _twoObjects, _module, true);
      var il = dynam.GetILGenerator();
      var methodInfo = propertyInfo.GetSetMethod();

      if (!methodInfo.IsStatic)
      {
        il.PushInstance(propertyInfo.DeclaringType);        
      }

      il.Emit(OpCodes.Ldarg_1);
      il.UnboxIfNeeded(propertyInfo.PropertyType);

      if (methodInfo.IsFinal || !methodInfo.IsVirtual)
      {
        il.Emit(OpCodes.Call, methodInfo);        
      }
      else
      {
        il.Emit(OpCodes.Callvirt, methodInfo);        
      }
      il.Emit(OpCodes.Ret);

      return (Action<object, object>)dynam.CreateDelegate(typeof(Action<object, object>));
    }

    public static Func<object, object> CreatePropertyGetterHandler(PropertyInfo propertyInfo)
    {
      var dynam = new DynamicMethod(string.Empty, typeof(object), _singleObject, _module, true);
      var il = dynam.GetILGenerator();
      var methodInfo = propertyInfo.GetGetMethod();

      if (!methodInfo.IsStatic)
      {
        il.PushInstance(propertyInfo.DeclaringType);        
      }

      if (methodInfo.IsFinal || !methodInfo.IsVirtual)
      {
        il.Emit(OpCodes.Call, methodInfo);        
      }
      else
      {
        il.Emit(OpCodes.Callvirt, methodInfo);        
      }

      il.BoxIfNeeded(propertyInfo.PropertyType);
      il.Emit(OpCodes.Ret);

      return (Func<object, object>)dynam.CreateDelegate(typeof(Func<object, object>));
    }

    static void PushInstance(this ILGenerator il, Type type)
    {
      il.Emit(OpCodes.Ldarg_0);
      if (type.IsValueType)
      {
        il.Emit(OpCodes.Unbox, type);        
      }
    }

    static void BoxIfNeeded(this ILGenerator il, Type type)
    {
      if (type.IsValueType)
      {
        il.Emit(OpCodes.Box, type);        
      }
    }

    static void UnboxIfNeeded(this ILGenerator il, Type type)
    {
      if (type.IsValueType)
      {
        il.Emit(OpCodes.Unbox_Any, type);        
      }
    }
  }
}