﻿// Experimental....

using System;
using System.Collections.Generic;
using System.Linq.Expressions;
using Neo4RestNet.ExpressionParser;

namespace Neo4RestNet.Core.Extensions
{
  public static class NodeTraversalExtensions
  {
    private static readonly ExpressionParser.ExpressionParser _expressionExpressionParser = 
      new ExpressionParser.ExpressionParser(new AtomConverter(), new ExpressionEvaluator(new AtomConverter()));

    public static IEnumerable<INode> TraverseNodes(this INode node, TraversalOrder traversalOrder, Expression<Func<ITraversalPosition, bool>> stopEvaluator,
                                     Expression<Func<ITraversalPosition, bool>> returnableEvaluator, string relationshipName, Direction direction)
    {
      return node.TraverseNodes(traversalOrder, _expressionExpressionParser.ConvertToJs(stopEvaluator),
                                _expressionExpressionParser.ConvertToJs(returnableEvaluator), relationshipName, direction); 
    }

    public static IEnumerable<INode> TraverseNodes(this INode node, TraversalOrder traversalOrder, Expression<Func<ITraversalPosition, bool>> stopEvaluator,
                                     ReturnableEvaluator returnableEvaluator, string relationshipName, Direction direction)
    {
      return node.TraverseNodes(traversalOrder, _expressionExpressionParser.ConvertToJs(stopEvaluator),
                                returnableEvaluator, relationshipName, direction);
    }

    public static IEnumerable<INode> TraverseNodes(this INode node, TraversalOrder traversalOrder, StopEvaluator stopEvaluator,
                                     Expression<Func<ITraversalPosition, bool>> returnableEvaluator, string relationshipName, Direction direction)
    {
      return node.TraverseNodes(traversalOrder, stopEvaluator,
                                _expressionExpressionParser.ConvertToJs(returnableEvaluator), relationshipName, direction);
    }

  }
}