using System.Linq.Expressions;

namespace Neo4RestNet.ExpressionParser
{
  public class JsNetConventionReferenceResolver : IReferenceResolver
  {
    private static string ConvertNetToJs(string name)
    {
      // Convention is to use lower case for first char in name
      return name.Substring(0, 1).ToLower() + name.Substring(1);      
    }

    public string GetMemberName(MemberExpression memberExpression)
    {
      // Convention is that all members are functions with no args
      return ConvertNetToJs(memberExpression.Member.Name) + "()";
    }

    public string GetMethodName(MethodCallExpression methodCallExpression)
    {
      return ConvertNetToJs(methodCallExpression.Method.Name);
    }
  }
}