﻿using System.Collections.Generic;
using Neo4RestNet.Core;
using Newtonsoft.Json.Linq;

namespace Neo4RestNet.Rest.Parsers
{
  public class NodeArrayParser
  {
    private readonly NodeParser _nodeParser;

    public NodeArrayParser()
    {
      _nodeParser = new NodeParser();
    }

    public IEnumerable<INode> Parse(string resultFromNodeTraversal)
    {
      // The result consists of an array of nodes
      var nodes = JArray.Parse(resultFromNodeTraversal);

      foreach (var node in nodes)
      {
        yield return _nodeParser.Parse((JObject)node);
      }
    }
  }
}
