using System.Collections.Generic;
using Neo4RestNet.Core;
using Newtonsoft.Json.Linq;

namespace Neo4RestNet.Rest.Traverser
{
  public class RelationshipConditionBuilder
  {
    private readonly RelationshipCondition _relationshipCondition;
    private static readonly IDictionary<Direction, string> _directionNames
      = new Dictionary<Direction, string>
          {
            { Direction.Incoming, "in" },
            { Direction.Outgoing, "out" },
            { Direction.All, "all"},
          };

    public RelationshipConditionBuilder(RelationshipCondition relationshipCondition)
    {
      _relationshipCondition = relationshipCondition;
    }

    internal JObject BuildObj()
    {
      var relationshipJson = new JObject
                               {
                                 {"type", JToken.FromObject(_relationshipCondition.RelationshipName)},
                                 {"direction", JToken.FromObject(_directionNames[_relationshipCondition.Direction])}
                               };
      return relationshipJson;      
    }

    public string Build()
    {
      return BuildObj().ToString();
    }
  }
}