﻿using System.Collections.Generic;
using System.Linq;
using Newtonsoft.Json.Linq;

namespace Neo4RestNet.Rest.Traverser
{
  public class RelationshipListConditionBuilder
  {
    private readonly IEnumerable<RelationshipConditionBuilder> _relationshipConditionBuilders;

    public RelationshipListConditionBuilder(IEnumerable<RelationshipConditionBuilder> relationshipConditionBuilders)
    {
      _relationshipConditionBuilders = relationshipConditionBuilders;
    }

    public string Build()
    {
      // Create an array of all conditions
      var array = new JArray(_relationshipConditionBuilders.Select(r => r.BuildObj()).ToArray());
      return new JProperty("relationships", array).ToString();
    }
  }
}
