using System;
using Newtonsoft.Json.Linq;

namespace Neo4RestNet.Rest.Traverser
{
  public class StopEvaluatorBuilder
  {
    private enum TypeOfStopEvaluatorBuilder
    {
      Javascript,
    }

    private readonly TypeOfStopEvaluatorBuilder _typeOfStopEvaluator;
    private readonly string _stopEvaluatorJs;

    public StopEvaluatorBuilder(string stopEvaluatorJs)
    {
      _typeOfStopEvaluator = TypeOfStopEvaluatorBuilder.Javascript;
      _stopEvaluatorJs = stopEvaluatorJs;      
    }

    public string Build()
    {
      JObject expressionJson;

      switch (_typeOfStopEvaluator)
      {
        case TypeOfStopEvaluatorBuilder.Javascript:
          expressionJson = BuildJavascript();
          break;
        default:
          throw new ArgumentOutOfRangeException();
      }

      return new JProperty("prune evaluator", expressionJson).ToString();
    }

    private JObject BuildJavascript()
    {
      var json = new JObject      
                   {
                     {"language", JToken.FromObject("javascript")},
                     {"body", JToken.FromObject(_stopEvaluatorJs)}
                   };
      return json;
    }
  }
}