using System.Collections.Generic;
using Neo4RestNet.Core;
using Newtonsoft.Json.Linq;

namespace Neo4RestNet.Rest.Traverser
{
  public class TraversalOrderBuilder
  {
    private static readonly IDictionary<TraversalOrder, string> _traversalOrderNames
      = new Dictionary<TraversalOrder, string>
          {
            { TraversalOrder.BreadthFirst, "breadth first" },
            { TraversalOrder.DepthFirst, "depth first" },
          };
    private readonly TraversalOrder _traversalOrder;

    public TraversalOrderBuilder(TraversalOrder traversalOrder)
    {
      _traversalOrder = traversalOrder;
    }

    public string Build()
    {
      return new JProperty("order", JToken.FromObject(_traversalOrderNames[_traversalOrder])).ToString();
    }
  }
}