﻿using System.Linq;
using Neo4RestNet.Rest.Parsers;
using NUnit.Framework;

namespace Neo4RestNet.Tests
{
  [TestFixture]
  public class PropertiesParserTests
  {
    private const string SimpleProperties = @"
      {
        ""property1"" : ""value1"",
        ""property2"" : ""value2"",
      }";


    // ReSharper disable InconsistentNaming
    [Test]
    public void parse_of_simpleproperties_should_succeed()
    {
      var parser = new PropertiesParser();
      var dictionary = parser.Parse(SimpleProperties);

      Assert.That(dictionary.Count, Is.EqualTo(2));
      Assert.That(dictionary.Keys.First(), Is.EqualTo("property1"));
      Assert.That(dictionary.Keys.Last(), Is.EqualTo("property2"));
      Assert.That(dictionary["property1"], Is.EqualTo("value1"));
      Assert.That(dictionary["property2"], Is.EqualTo("value2"));
    }
    // ReSharper restore InconsistentNaming
  }
}
