﻿using System.Linq;
using Neo4RestNet.Rest.Parsers;
using NUnit.Framework;

namespace Neo4RestNet.Tests
{
  [TestFixture]
  public class RelationshipParserTests
  {
    private const string RelationshipArrayJson = @"
      [ {
        ""start"" : ""http://localhost:9999/node/53"",
        ""data"" : {},
        ""property"" : ""http://localhost:9999/relationship/1/properties/{key}"",
        ""self"" : ""http://localhost:9999/relationship/1"",
        ""properties"" : ""http://localhost:9999/relationship/1/properties"",
        ""type"" : ""test"",
        ""end"" : ""http://localhost:9999/node/54""
      } ]";    


    // ReSharper disable InconsistentNaming
    [Test]
    public void parse_of_relationship_succeeds()
    {
      var parser = new RelationshipParser();
      var relationships = parser.ParseArray(RelationshipArrayJson);
      var relationship = relationships.First();

      Assert.That(relationship, Is.Not.Null);
      Assert.That(relationship.StartNode, Is.Not.Null);
      Assert.That(relationship.EndNode, Is.Not.Null);
      Assert.That(relationship.Name, Is.EqualTo("test"));
    }
    // ReSharper restore InconsistentNaming
  }
}
