﻿using System.Linq;
using Neo4RestNet.Rest.Parsers;
using NUnit.Framework;

namespace Neo4RestNet.Tests
{
  [TestFixture]
  public class TraversalResultParserTests
  {
    private const string NodeTraversalResult = @"[
      { ""self"": ""http://localhost:9999/node/64"",
        ""data"": { ""name"": ""Thomas Anderson"" },
      },
      { ""self"": ""http://localhost:9999/node/635"",
        ""data"": { ""name"": ""Agent Smith"" },
      }
    ]";


    // ReSharper disable InconsistentNaming
    [Test]
    public void parse_of_node_traversal_should_succeed()
    {
      var parser = new NodeArrayParser();
      var nodes = parser.Parse(NodeTraversalResult);

      Assert.That(nodes.Count(), Is.EqualTo(2));
      Assert.That(nodes.First().Self, Is.EqualTo("http://localhost:9999/node/64"));
      Assert.That(nodes.Last().Self, Is.EqualTo("http://localhost:9999/node/635"));
    }
    // ReSharper restore InconsistentNaming
  }
}
